// ------------------------------------------------------------------------------
// <auto-generated>
//    Generated by avrogen, version 1.9.0.0
//    Changes to this file may cause incorrect behavior and will be lost if code
//    is regenerated
// </auto-generated>
// ------------------------------------------------------------------------------
namespace io.axual.client.example.schema
{
	using System;
	using System.Collections.Generic;
	using System.Text;
	using Avro;
	using Avro.Specific;
	
	public partial class Application : ISpecificRecord
	{
		public static Schema _SCHEMA = Avro.Schema.Parse(@"{""type"":""record"",""name"":""Application"",""namespace"":""io.axual.client.example.schema"",""fields"":[{""name"":""name"",""doc"":""The name of the application"",""type"":""string""},{""name"":""version"",""doc"":""(Optional) The application version"",""default"":null,""type"":[""null"",""string""]},{""name"":""owner"",""doc"":""The owner of the application"",""default"":null,""type"":[""null"",""string""]}]}");
		/// <summary>
		/// The name of the application
		/// </summary>
		private string _name;
		/// <summary>
		/// (Optional) The application version
		/// </summary>
		private string _version;
		/// <summary>
		/// The owner of the application
		/// </summary>
		private string _owner;
		public virtual Schema Schema
		{
			get
			{
				return Application._SCHEMA;
			}
		}
		/// <summary>
		/// The name of the application
		/// </summary>
		public string name
		{
			get
			{
				return this._name;
			}
			set
			{
				this._name = value;
			}
		}
		/// <summary>
		/// (Optional) The application version
		/// </summary>
		public string version
		{
			get
			{
				return this._version;
			}
			set
			{
				this._version = value;
			}
		}
		/// <summary>
		/// The owner of the application
		/// </summary>
		public string owner
		{
			get
			{
				return this._owner;
			}
			set
			{
				this._owner = value;
			}
		}
		public virtual object Get(int fieldPos)
		{
			switch (fieldPos)
			{
			case 0: return this.name;
			case 1: return this.version;
			case 2: return this.owner;
			default: throw new AvroRuntimeException("Bad index " + fieldPos + " in Get()");
			};
		}
		public virtual void Put(int fieldPos, object fieldValue)
		{
			switch (fieldPos)
			{
			case 0: this.name = (System.String)fieldValue; break;
			case 1: this.version = (System.String)fieldValue; break;
			case 2: this.owner = (System.String)fieldValue; break;
			default: throw new AvroRuntimeException("Bad index " + fieldPos + " in Put()");
			};
		}

		public override string ToString()
		{
			return $"[Application]: name = {name}, version = {version}, owner = {owner}";
		}
	}
}
